=== doc/requirements.txt ===
matplotlib
recommonmark
sphinx>=2
sphinx_autobuild
PyYAML>=4.2b1
docutils
csvkit
yamllint
pathlib
ipykernel
nbsphinx
pytest
path.py
cython
statsmodels
jupyter
cmake
numpy
numpydoc
scipy
example
Image
seaborn
sphinx_gallery
mock
breathe
